# Project and Portfolio 3

# Introduction
This project from Project and Portfolio 3 within the Game Design Bachelor's degree program, focuses on building and adding mechanics to an existing and working game project. In this project, I have designed and implemented a bridge tiling system. This system not only brings the ability to implement bridges into the game, but does it with a level of simplicity that makes it a breeze for any developer to quickly implement. Furthermore, you are able to use any existing or newly created tile as a bridge tile, giving further versitility to the overall system.

## What Went Right
***Communication*** --- Having access to the Full Sail discord and having quick access to both professors as well as fellow students when questions came up throughout the project was a tremendous help. Any issue I ran into I was able to quickly get advice on how to solve it. 

***UE5 Blueprinting*** --- Working with blueprints have been a bit of a gift and curse for me. A gift, because they have always been fairly easy for me to read, follow along, and figure out what is going on. A curse, because some things to me have always just felt out of order so to speak when reading them. I have also been able to keep my blueprints fairly clean so that most if not all lines are visible and easy to follow. However, throughout this project, a few extra things seemed to click into place that have made reading and creating blueprints just that much more easier overall. 

***Source Control*** --- While it was not required to be done for this project, I did keep my own repository and source controlling for the project. This is something I have attempted to do and continue doing since starting this degree path.  You never know what could happen. And there was actually an instance during the course of this project where source control was an immense help.

***Quick Adjusting*** --- Originally starting out on this project, I had a few different ideas in mind on how I wanted to implement this mechanic. However, once starting on the project I quickly recognized that I would not have realistically enough time to implement it in its original form so I had to quickly adjust and map out a different way to do it. In the end, it was actually much more beneficial reworking it as I, after changing implementation, was not only able to create a better system for gameplay, but also create an easier way to implement the mechanic within the level design as well. This allowed for any tile to be used, as well as the system to be more quickly added and implemented within any level. 

***Time Management*** --- While this does somewhat go in hand with Quick Adjusting, it gets its own tab as this was both good and bad. The good, being as seen above, and I was able to easily focus on what I was doing, and was able to complete what I was working on fairly well. However, there were some pitfalls. That is covered below.

## What Went Wrong
***Time Management*** --- Here is the other half of the whole time management. The good being the focus. The bad, being derailed on that focus. And in turn, quickly lost sight of what I was doing, and made a bit of a dash at the end to finish within the alloted time. There was a weeklong required event going on that I spent more with than I probably should have, and during that time, I didn't work on the project at all for the most part. While I learned a lot from the event, I should have taken better care of keeping up with the project than I did. Another issue that came up was a complete break down of my operating system on the main computer system I work off of. This also lost me about a day in trouble shooting and resets.

***System Failure*** --- This was actually kind of an oddball issue to run into. As mentioned above in the second half of time management, I had a complete system failure at an operating system level of the main computer system I work on. Recently I had been pushed to Windows 11 from Windows 10, and was not able to roll back. And while I worked with it for a time. Eventually everything came to a head and I was not able to boot the system at all. I spent a day trouble shooting, ruling out things like hardware failure, malicious software, registry corruption, program corruption, driver corruption. Nothing seemed fruitful. In the end, I ended up spending an entire night after a day of testing, wiping drives and completely reinstalling the OS from blank drives. Afterwards everything seemed to run smoothly and also better on resources as well. The best I can sermise is something corrupted or failed during the OS upgrade that eventually caused the failure. This also ties in with the above mentioned source control as if I had not been getting in the habit of using source control in every project, I would have, in this instance, lost all progress and had to start from scratch with only a few days remaining. 

***Research*** --- This one is fairly short. While for the most part it went alright, what I felt went wrong is I would have prefered to have more than just one source for the idea of the mechanic to reference. 

***Driver Addition*** --- This goes in hand with the failing end of time management. While adding another students mechanic (Driver assignment) overall went well, originally I wanted to impliment it similar to how I did it with my bridge mechanic. However, due to poor time management, I was not able to do that, and had to essentially implement it in a near mirror of how it was originally designed. 

***Mechanic Error*** --- After completing my designed mechanic, I had afterwards found an error within the blueprints that I had originally overlooked. This caused a minor error that if the right circumstances happened within a level, the mechanic would not display correctly. Luckily though, once I had found the error, I was able to quickly diagnose the issue, and implement a quick correction. 

## Conclusion
Overall I feel this project was a success. The mechanics were implemented I feel seemlessly and are pretty straight forward. Both in game play, and level design stances. The added clarity gained in working with blueprints was also quite the benefit as well. However, this project could have easily and quickly become a disaster had I not implemented source control from the very beginning. Biggest lesson to take away from this is just the affirmation to always use source control. It will save you a massive headache if it is actually ever needed.